package Kirjalista;



/**
 * Luokka, joka keskustelee käyttöliittymän kanssa 
 * - Välittää tietoja käyttöliittymän ja kirjojen sekä genrejen välillä
 */
public class Kirjasto {
    private Kirjat kirjat = new Kirjat();
    private GenreRelaatio genreRelaatio;
    //private Genret genret;
    
    
    
    /**
     * @param kirja Lisättävä kirja
     * @throws SailoException Jos kirjaa ei voi lisätä
     */
    public void lisaaKirja(Kirja kirja) throws SailoException {
        kirjat.lisaa(kirja);
    }
    
    
    /**
     * Ottaa taulukollisen genreId:itä ja liima ne kirjan id:n kanssa yhteen. Lisää lopuksi listaan
     * @param kirjaId Kirjan id
     * @param genreId Taulukko kaikista kirjan genrejen id:istä
     */
    public void lisaaGenreRelaatio(int kirjaId, int[] genreId) {
        for (int i = 0; i < genreId.length; i++) {
            genreRelaatio.lisaa(new KirjanGenre(kirjaId, genreId[i])); 
        }
    }
    
    // TODO haku ja poisto genreRelaatioille
    
    /**
     * @param indeksi Indeksipaikka, josta kirja haetaan
     * @return Kirja annetussa indeksipaikassa
     * @throws IndexOutOfBoundsException Jos indeksi laiton
     */
    public Kirja haeKirja(int indeksi) throws IndexOutOfBoundsException {
        return kirjat.hae(indeksi);
    }
    
    
    /**
     * @return Kirjojen lukumäärä
     */
    public int getKirjaLkm() {
        return this.kirjat.getLkm();
    }
    /*
    public Genre haeGenre(Kirja kirja) {
        GenreRelaatio.haeGenret();
    }
    */
}
