package fxKirjalista;

import Kirjalista.Kirja;
import Kirjalista.Kirjasto;
import Kirjalista.SailoException;
import fi.jyu.mit.fxgui.ComboBoxChooser;
import javafx.fxml.FXML;
import javafx.scene.control.TextField;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;


/**
 * Kirjan liäämisikkunan käsittelijä
 */
public class LisaaController {

  
    @FXML private ComboBoxChooser<?> comboboxGenre;
    @FXML private TextField textKirjailija;
    @FXML private TextField textNimi;
    @FXML private TextField textSarja;
    @FXML private TextField textSivu;
    @FXML private TextField textVuosi;

    private Kirjasto kirjasto;
    
    private KirjalistaGUIController isanta;
    
    @FXML void handleLisaaOK() {
        uusiKirja();
        //Dialogs.showMessageDialog("Vielä ei osata lisätä");
        ModalController.closeStage(textNimi);
    }


    @FXML void handleMuokkaaOK() {
        Dialogs.showMessageDialog("Vielä ei osata muokata");
        ModalController.closeStage(textNimi);
    }

    
    @FXML void handlePoista() {
        KirjalistaGUIController.poistoVahvistus();
        ModalController.closeStage(textNimi);

    }
    
    
    /**
     * Asettaa controllerille viitteen kirjasto-olioon
     * @param kirjasto Kirjasto-luokan olio, johon viite asetetaan
     */
    public void setKirjasto(Kirjasto kirjasto) {
        this.kirjasto = kirjasto;
    }
    
    
    
    /**
     * Asettaa olion "isännäksi" kirjalistan pääikkunan kontrollerin, jotta
     * keskustelu kontrollerien välillä helpompaa
     * @param isanta Pääikkunan kontrolleri
     */
    public void setIsanta(KirjalistaGUIController isanta) {
        this.isanta = isanta;
    }
    
    
    /**
     * Luo kirjan ja antaa sille id:n. Pyrkii lisäämään sen kirjat-olion
     * taulukkoon ja antaa virheen, jos ei onnistu.
     */
    protected void uusiKirja() {
        Kirja uusi = new Kirja();
        uusi.esimerkkiKirja();
        uusi.rekisteroi();
        try {
            kirjasto.lisaaKirja(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelma " + e.getMessage());
            return;
        }
        isanta.hae(uusi.getId());
    
    }
    
}
